unit T_BiancoRect;


{
                                   \\\\\/////
                                   /  _   _  \
                                  (| (.) (.) |)
 _______________________________.OOOo__( )__oOOO.______________________________
|                                                                              |
|                               This is my Tcomponent                          |
|                                    Ciao Marco                                |
|                              Email bianco@arcanet.it                         |
|                                                                              |
| DATA:      INIZIO:    FINE:      LAVORO:                                     |
|                                                                              |
| 31-08-97,  20:53:21,  21:28:55   3 METODI PER IL MANUAL RECT.                |
|                                  PROPERTY _W E _H.                           |
| 31-08-97,  21:40:55,  01:01:28   FATTO AUTOMATIC RECT.                       |
| 03-09-97,  17:36:59,  18:21:26   CAPTURE IMAGE!                              |
| 04-09-97,  20:16:12,
|_______________________________.oooO__________________________________________|
                                (   )        Oooo.
                                 \ (         (   )
                                  \_)         ) /
                                             (_/

}


interface
      //WinTypes, WinProcs,

uses    
SysUtils, Messages,Windows, Classes, Graphics, Controls,
Forms, Dialogs, ExtCtrls;

Type
  TScreenRiferiment=(srScreen,srParent);
  TAutomationType=(atDirect,atDirectXY,atDirectYX);
  TBiancoRect=class(TComponent)
  Private
   REC:TRECT;
   ScreenDC:HDC;
   LASTTOP,LASTLEFT:INTEGER;
   _W,_H:INTEGER;//WIDTH,HEIGHT OF THE RECT
   VIS:BOOLEAN;
   FT:ARRAY[1..2,1..4] OF INTEGER; //TOP,LEFT,BOTTOM,RIGHT DI PARTENZA E ARRIVO
   ERRORE:INTEGER;
   Rife:TScreenRiferiment;
   INTERV:WORD;
   Auto:TAutomationType;
   TRAIL:BOOLEAN;//VEDI LA SCIA
   NUM_T:INTEGER;//NUMERO DI RECT.
   DELTA,POSIT:ARRAY[1..4] OF DOUBLE; //DELTAXY TRANSLATION AND CURRENT RECT
   //INTERNAL PROCEDURES
   PROCEDURE EXECUTE_DIRECT;
   PROCEDURE EXECUTE_XY;
   PROCEDURE EXECUTE_YX;
   //SET WIDTH AND HEIGHT
   PROCEDURE SET_W(VALUE:INTEGER);
   PROCEDURE SET_H(VALUE:INTEGER);
   PROCEDURE SET_SCREEN(VALUE:TSCREENRIFERIMENT);
   //IT DOESN'T DO ANITHING...
   PROCEDURE SET_ERRORE(VALUE:INTEGER);
  Protected
  Public
   constructor Create(AOwner: TComponent); override;
   // destructor Destroy; virtual;

   procedure Delay(msecs:WORD); //DELAY MSECS MILLISECONDS

   //THE METHOD FOR THE AUTOMATIC RECT
   FUNCTION EXECUTE:BOOLEAN;
   FUNCTION MOVECONTROL(C:TCONTROL;X,Y:INTEGER):BOOLEAN;

   //3 METHODS FOR THE MANUAL RECT
   PROCEDURE SHOWRECT(_LEFT,_TOP:INTEGER);
   PROCEDURE MOVERECT(_LEFT,_TOP:INTEGER);
   PROCEDURE CAPTUREIMAGE(IMAGE1:TIMAGE);
   PROCEDURE DESTROYRECT;
  Published
   //PROPERTY PER MANUAL RECT
   PROPERTY ManualRectWidth:INTEGER READ _W WRITE SET_W;
   PROPERTY ManualRectHeight:INTEGER READ _H WRITE SET_H;
   //PROPERTY PER AUTOMATIC RECT
   PROPERTY FromTop:INTEGER READ FT[1,1] WRITE FT[1,1];
   PROPERTY FromLeft:INTEGER READ FT[1,2] WRITE FT[1,2];
   PROPERTY FromRight:INTEGER READ FT[1,3] WRITE FT[1,3];
   PROPERTY FromBottom:INTEGER READ FT[1,4] WRITE FT[1,4];
   PROPERTY ToTop:INTEGER READ FT[2,1] WRITE FT[2,1];
   PROPERTY ToLeft:INTEGER READ FT[2,2] WRITE FT[2,2];
   PROPERTY ToRight:INTEGER READ FT[2,3] WRITE FT[2,3];
   PROPERTY ToBottom:INTEGER READ FT[2,4] WRITE FT[2,4];
   PROPERTY ScreenRiferiment:TScreenRiferiment READ RIFE WRITE SET_SCREEN;
   PROPERTY AutomationStyle:TAutomationType READ AUTO WRITE AUTO;
   PROPERTY ShowTrail:BOOLEAN READ TRAIL WRITE TRAIL;
   PROPERTY NumberOfRect:INTEGER READ NUM_T WRITE NUM_T;
   PROPERTY Interval:WORD READ INTERV WRITE INTERV;
   //ALWAIS ACTIVE
   PROPERTY LastError:INTEGER READ ERRORE WRITE SET_ERRORE;//READ ONLY
  end;

procedure Register;

implementation

procedure TBIANCORECT.Delay(msecs:WORD);
 var
   FirstTickCount:longint;
 begin
  FirstTickCount:=GetTickCount;
  repeat
  // Application.ProcessMessages;
  until ((GetTickCount-FirstTickCount) >= Longint(msecs));
 end;

//BOOL BitBlt(
//    HDC  hdcDest,	// handle of destination device context
//    int  nXDest,	// x-coordinate of destination rectangle's upper-left corner
//    int  nYDest,	// x-coordinate of destination rectangle's upper-left corner
//    int  nWidth,	// width of destination rectangle
//    int  nHeight,	// height of destination rectangle
//    HDC  hdcSrc,	// handle of source device context
//    int  nXSrc,	// x-coordinate of source rectangle's upper-left corner
//    int  nYSrc,	// y-coordinate of source rectangle's upper-left corner
//    DWORD  dwRop 	// raster operation code
//   );

PROCEDURE TBIANCORECT.CAPTUREIMAGE(IMAGE1:TIMAGE);
 var
  newBitmap: TBitmap;
 begin
  IF VIS THEN
   BEGIN
    newBitmap:=TBitmap.Create;
    try
     Image1.Picture.Graphic:=newBitmap;
     Image1.Picture.Graphic.Width:=_W;
     Image1.Picture.Graphic.Height:=_H;
     try
      BitBlt(Image1.Picture.Bitmap.Canvas.Handle,
             0,
             0,
             _W,
             _H,
             ScreenDC,
             REC.LEFT,
             REC.TOP,
             SRCCOPY);
     finally
      //...
     end;
    finally
     newBitmap.Free;
    end;
    ERRORE:=0;
   END
  ELSE
   ERRORE:=2;
 end;


PROCEDURE TBIANCORECT.SET_ERRORE(VALUE:INTEGER);
 BEGIN
  //NOTHING TO DO...
  {
  CODE   DESCRIPTION
   0      ALL RIGHT.
   1      THE MANUAL RECT IS ALREDY VISIBLE.
   2      THE MANUAL RECT IS NOT VISIBLE.
   3      YOU CAN NOT CHANGE THE SCREEN RIFERIMENT WHILE MANUAL RECT IS VISIBLE
  }

 END;

PROCEDURE TBIANCORECT.SET_SCREEN(VALUE:TSCREENRIFERIMENT);
 BEGIN
  IF VIS THEN
   ERRORE:=3
  ELSE
   BEGIN
    ERRORE:=0;
    RIFE:=VALUE;
   END;
 END;

//SETTING THE PROPERTIES...
PROCEDURE TBIANCORECT.SET_W(VALUE:INTEGER);
 BEGIN
  //SET THE WIDTH
  _W:=VALUE;
  IF VIS THEN
   MOVERECT(LASTLEFT,LASTTOP);
  ERRORE:=0;
 END;

PROCEDURE TBIANCORECT.SET_H(VALUE:INTEGER);
 BEGIN
  //SET THE HEIGHT
  _H:=VALUE;
  IF VIS THEN
   MOVERECT(LASTLEFT,LASTTOP);
  ERRORE:=0;
 END;

// THIS IS 3 METHODS TO SHOW, MOVE AND HIDE THE MANUAL RECT
PROCEDURE TBIANCORECT.SHOWRECT(_LEFT,_TOP:INTEGER);
 BEGIN
  // SHOW THE RECT FOR THE FIRST TIME AT THE _LEFT,_TOP POSITION.
  // THE DIMENSION OF THE RECT IS _W AND _H (Width AND Height).
  IF NOT VIS THEN
   BEGIN
    LASTTOP:=_TOP;
    LASTLEFT:=_LEFT;
    //INITIALIZE THE RIFERIMENT COORDINATES
    IF RIFE=srScreen then
     ScreenDC := GetDC(0)
    else
     ScreenDC := GetDC((owner as TForm).Handle);  //Alwais TForm

    REC.top:=_TOP;
    REC.left:=_LEFT;
    REC.bottom:=_TOP+_H;
    REC.right:=_LEFT+_W;
    DrawFocusRect(ScreenDC,REC);
    VIS:=TRUE;
    ERRORE:=0;
   END
  ELSE
   ERRORE:=1;
 END;

PROCEDURE TBIANCORECT.MOVERECT(_LEFT,_TOP:INTEGER);
 BEGIN
  // MOVE THE CURRENT RECT TO THE _LEFT,_TOP POSITION.
  IF VIS THEN
   BEGIN
    //DESTROY THE CURRENT RECT
    DrawFocusRect(ScreenDC,REC);
    //CHANGE THE POSITION
    REC.top:=_TOP;
    REC.left:=_LEFT;
    REC.bottom:=_TOP+_H;
    REC.right:=_LEFT+_W;
    DrawFocusRect(ScreenDC,REC);
    ERRORE:=0;
    LASTTOP:=_TOP;
    LASTLEFT:=_LEFT;
   END
  ELSE
   ERRORE:=2;
 END;

PROCEDURE TBIANCORECT.DESTROYRECT;
 BEGIN
  // DESTROY THE CURRENT RECT .
  IF VIS THEN
   BEGIN
    DrawFocusRect(ScreenDC,REC);
    VIS:=FALSE;
    ReleaseDC(0,ScreenDC);
    ERRORE:=0
   END
  ELSE
   ERRORE:=2;
 END;

//HERE IT IS THE METHOD FOR THE AUTOMATIC RECT
FUNCTION TBIANCORECT.MOVECONTROL(C:TCONTROL;X,Y:INTEGER):BOOLEAN;
 BEGIN
  //SET THE FROM* AND TO* PROPERTY
  FT[1,1]:=C.TOP;
  FT[1,2]:=C.LEFT;
  FT[1,3]:=C.LEFT+C.WIDTH;
  FT[1,4]:=C.TOP+C.HEIGHT;
  FT[2,1]:=Y;
  FT[2,2]:=X;
  FT[2,3]:=X+C.WIDTH;
  FT[2,4]:=Y+C.HEIGHT;
  IF EXECUTE THEN
   BEGIN
    RESULT:=TRUE;
    ERRORE:=0;
    C.TOP:=Y;
    C.LEFT:=X;
   END
  ELSE
   RESULT:=FALSE;
 END;


FUNCTION TBIANCORECT.EXECUTE:BOOLEAN;
 VAR
  A:INTEGER;
 BEGIN
  IF NOT VIS THEN
   BEGIN
    //Set the screen Rif.
    IF RIFE=srScreen then
     ScreenDC := GetDC(0)
    else
     ScreenDC := GetDC((owner as TForm).Handle); //Alwais TForm
    //Check the ExplodeType
    FOR A:=1 TO 4 DO    //SET THE DELTA X,Y
     DELTA[A]:=(FT[2,A]-FT[1,A])/NUM_T;
    CASE AUTO OF
     atDirect:EXECUTE_DIRECT;
     atDirectXY:EXECUTE_XY;
     atDirectYX:EXECUTE_YX;
    END;
    ReleaseDC(0,ScreenDC);//FREE MEMORY
    ERRORE:=0;
   END
  ELSE
   ERRORE:=1;
  RESULT:=NOT VIS;//THE OTHER RECT CANNOT BE VISIBLE
 END;

PROCEDURE TBIANCORECT.EXECUTE_DIRECT;
 VAR
  A,L,B,LOOP,D:INTEGER;
 BEGIN
  IF TRAIL THEN // LASCIA LA SCIA
   LOOP:=2
  ELSE
   LOOP:=1;
  D:=INTERV DIV LOOP;
  FOR L:=1 TO LOOP DO  // THE SECOND LOOP DELETE THE TRAIL
   BEGIN
    FOR A:=1 TO 4 DO //SET THE 4 STARTING POINT
     POSIT[A]:=FT[1,A];
    FOR A:=1 TO NUM_T DO //NUMBER OF RECT
     BEGIN
      //SHOW THE CURRENT RECT
      REC.top:=TRUNC(POSIT[1]);
      REC.left:=TRUNC(POSIT[2]);
      REC.right:=TRUNC(POSIT[3]);
      REC.bottom:=TRUNC(POSIT[4]);
      DrawFocusRect(ScreenDC,REC);   //DRAW RECT
      FOR B:=1 TO 4 DO
       POSIT[B]:=POSIT[B]+DELTA[B];
      DELAY(D);
      IF NOT TRAIL THEN
       DrawFocusRect(ScreenDC,REC);  //DELETE THE RECT
     END;
   END;
 END;

PROCEDURE TBIANCORECT.EXECUTE_XY;
 VAR
  A,L,LOOP,B,C,D,E:INTEGER;
 BEGIN
  IF TRAIL THEN // LASCIA LA SCIA
   LOOP:=2
  ELSE
   LOOP:=1;
  D:=(INTERV DIV LOOP) DIV 2;
  E:=ABS((INTERV DIV LOOP)-D);
  FOR L:=1 TO LOOP DO  // THE SECOND LOOP DELETE THE TRAIL
   BEGIN
    //ADJUST LEFT VALUE
    REC.top:=FT[1,1];
    REC.bottom:=FT[1,4];
    C:=NUM_T DIV 2;
    FOR A:=1 TO 4 DO //SET THE 4 STARTING POINT
     POSIT[A]:=FT[1,A];
    //CAMBIA SOLO IL LEFT
    FOR A:=1 TO C DO //SEMI NUMBER OF RECT
     BEGIN
      //SHOW THE CURRENT RECT
      REC.left:=TRUNC(POSIT[2]);
      REC.right:=TRUNC(POSIT[3]);
     // REC.BOTTOM:=TRUNC(POSIT[4]);
      DrawFocusRect(ScreenDC,REC);   //DRAW RECT
      FOR B:=2 TO 3 DO                //ADJ ONLY X COORDINATES
       POSIT[B]:=POSIT[B]+DELTA[2]*2;
      DELAY(D);
      IF NOT TRAIL THEN
       DrawFocusRect(ScreenDC,REC);   //DRAW RECT
     END;
    //RICALCOLA DELTA 3
     DELTA[3]:=(FT[2,3]-REC.RIGHT)/C;

    //ORA CAMBIA TOP,RIGHT E BOTTOM
    FOR A:=1 TO C DO //SEMI NUMBER OF RECT
     BEGIN
      //SHOW THE CURRENT RECT
      REC.TOP:=TRUNC(POSIT[1]);
      REC.right:=TRUNC(POSIT[3]);
      REC.BOTTOM:=TRUNC(POSIT[4]);
      DrawFocusRect(ScreenDC,REC);   //DRAW RECT
      DELAY(E);
      IF NOT TRAIL THEN
       DrawFocusRect(ScreenDC,REC);   //DRAW RECT
      POSIT[3]:=POSIT[3]+DELTA[3]/2;
      POSIT[4]:=POSIT[4]+DELTA[4]*2;
      POSIT[1]:=POSIT[1]+DELTA[1]*2;//DOPPIO DELTA PERCHE' META' LOOP
     END;
   END;
 END;

PROCEDURE TBIANCORECT.EXECUTE_YX;
 VAR
  A,L,LOOP,B,C,D,E:INTEGER;
 BEGIN
  IF TRAIL THEN // LASCIA LA SCIA
   LOOP:=2
  ELSE
   LOOP:=1;
  D:=(INTERV DIV LOOP) DIV 2;
  E:=ABS((INTERV DIV LOOP)-D);
  FOR L:=1 TO LOOP DO  // THE SECOND LOOP DELETE THE TRAIL
   BEGIN
    //ADJUST TOP VALUE
    REC.LEFT:=FT[1,2];
    REC.RIGHT:=FT[1,3];
    C:=NUM_T DIV 2;
    FOR A:=1 TO 4 DO //SET THE 4 STARTING POINT
     POSIT[A]:=FT[1,A];
    //CAMBIA SOLO IL TOP
    FOR A:=1 TO C DO //SEMI NUMBER OF RECT
     BEGIN
      //SHOW THE CURRENT RECT
      REC.TOP:=TRUNC(POSIT[1]);
      REC.BOTTOM:=TRUNC(POSIT[4]);
     // REC.BOTTOM:=TRUNC(POSIT[4]);
      DrawFocusRect(ScreenDC,REC);   //DRAW RECT
      //ADJ ONLY Y COORDINATES
      POSIT[1]:=POSIT[1]+DELTA[1]*2;
      POSIT[4]:=POSIT[4]+DELTA[1]*2;
      DELAY(D);
      IF NOT TRAIL THEN
       DrawFocusRect(ScreenDC,REC);   //DRAW RECT
     END;
    //RICALCOLA DELTA 4
     DELTA[4]:=(FT[2,4]-REC.BOTTOM)/C;

    //ORA CAMBIA TOP,RIGHT E BOTTOM
    FOR A:=1 TO C DO //SEMI NUMBER OF RECT
     BEGIN
      //SHOW THE CURRENT RECT
      REC.LEFT:=TRUNC(POSIT[2]);
      REC.right:=TRUNC(POSIT[3]);
      REC.BOTTOM:=TRUNC(POSIT[4]);
      DrawFocusRect(ScreenDC,REC);   //DRAW RECT
      DELAY(E);
      IF NOT TRAIL THEN
       DrawFocusRect(ScreenDC,REC);   //DRAW RECT
      FOR B:=2 TO 3 DO
       POSIT[B]:=POSIT[B]+DELTA[B]*2;
       POSIT[4]:=POSIT[4]+DELTA[4]/2;
//      POSIT[1]:=POSIT[1]+DELTA[1]*2;//DOPPIO DELTA PERCHE' META' LOOP
     END;
   END;
 END;

//*****************************************************************************
Constructor TBiancoRect.Create(AOwner: TComponent);
 Begin
  Inherited Create(Aowner);
//  RANDOMIZE;
//  IF RANDOM(5)=0 THEN
//   SHOWMESSAGE('Bianchini Marco'+#13+'E-Mail bianco@arcanet.it');
 End;

    {
DESTRUCTOR TBiancoRect.DESTROY;
 Begin
  Inherited DESTROY;
  ReleaseDC(0,ScreenDC);
 End;
    }

procedure Register;
 begin
  RegisterComponents('Bianco', [TBiancoRect]);
 end;

end.

{
PROCEDURE TBIANCORECT.EXECUTE_X(TR:BOOLEAN);
 VAR
  A,L,LOOP:INTEGER;
  DELTA,POSIT:ARRAY[1..2] OF DOUBLE; //DELTAX TRANSLATION AND CURRENT RECT
 BEGIN
  IF TR THEN // LASCIA LA SCIA
   LOOP:=2
  ELSE
   LOOP:=1;
  //FIN DELTA
  DELTA[1]:=(FT[2,2]-FT[1,2])/NUM_T;
  DELTA[2]:=(FT[2,3]-FT[1,3])/NUM_T;
  //START TH LOOP
  FOR L:=1 TO LOOP DO  // THE SECOND LOOP DELETE THE TRAIL
   BEGIN
    //SET THE 4 STARTING POINT
    POSIT[1]:=FT[1,2];
    POSIT[2]:=FT[1,3];
    FOR A:=1 TO NUM_T DO //NUMBER OF RECT
     BEGIN
      //SHOW THE CURRENT RECT
      REC.left:=TRUNC(POSIT[1]);
      REC.right:=TRUNC(POSIT[2]);
      DrawFocusRect(ScreenDC,REC);   //DRAW RECT
      POSIT[1]:=POSIT[1]+DELTA[1];
      POSIT[2]:=POSIT[2]+DELTA[2];
      DELAY(INTERV DIV 2);
      IF NOT TR THEN
       BEGIN
        DELAY(INTERV);
        DrawFocusRect(ScreenDC,REC);  //DELETE THE RECT
       END;
     END;
   END;
 END;

PROCEDURE TBIANCORECT.EXECUTE_Y(TR:BOOLEAN);
 VAR
  A,L,LOOP:INTEGER;
  DELTA,POSIT:ARRAY[1..2] OF DOUBLE; //DELTAX TRANSLATION AND CURRENT RECT
 BEGIN
  IF TR THEN // LASCIA LA SCIA
   LOOP:=2
  ELSE
   LOOP:=1;
  //FIN DELTA
  DELTA[1]:=(FT[2,1]-FT[1,1])/NUM_T;
  DELTA[2]:=(FT[2,4]-FT[1,4])/NUM_T;
  //START TH LOOP
  FOR L:=1 TO LOOP DO  // THE SECOND LOOP DELETE THE TRAIL
   BEGIN
    //SET THE 4 STARTING POINT
    POSIT[1]:=FT[1,1];
    POSIT[2]:=FT[1,4];
    FOR A:=1 TO NUM_T DO //NUMBER OF RECT
     BEGIN
      //SHOW THE CURRENT RECT
      REC.Top:=TRUNC(POSIT[1]);
      REC.Bottom:=TRUNC(POSIT[2]);
      DrawFocusRect(ScreenDC,REC);   //DRAW RECT
      POSIT[1]:=POSIT[1]+DELTA[1];
      POSIT[2]:=POSIT[2]+DELTA[2];
      DELAY(INTERV DIV 2);
      IF NOT TR THEN
       BEGIN
        DELAY(INTERV DIV 2);
        DrawFocusRect(ScreenDC,REC);  //DELETE THE RECT
       END;
     END;
   END;
 END;

}
